const GObject = imports.gi.GObject;
const Main = imports.ui.main;
const PanelMenu = imports.ui.panelMenu;
const PopupMenu = imports.ui.popupMenu;
const Menu = Main.panel.statusArea.aggregateMenu._system.menu;
const SubMenu = Main.panel.statusArea.aggregateMenu._system._sessionSubMenu;
const SystemActions = Main.panel.statusArea.aggregateMenu._system._systemActions;

let bindFlags = GObject.BindingFlags.DEFAULT | GObject.BindingFlags.SYNC_CREATE;

function init() {}

function enable() {
Menu.box.remove_child(SubMenu);

separator1 = new PopupMenu.PopupSeparatorMenuItem;
Menu.addMenuItem(separator1);

logout = new PopupMenu.PopupImageMenuItem(_('Logout'), 'application-exit-symbolic');
logout.connect('activate', () => { SystemActions.activateLogout(); });
Menu.addMenuItem(logout);
SystemActions.bind_property('can-logout', logout, 'visible', bindFlags);

switchUser = new PopupMenu.PopupImageMenuItem(_('Switch User'), 'system-switch-user-symbolic.svg');
switchUser.connect('activate', () => { SystemActions.activateSwitchUser(); });
Menu.addMenuItem(switchUser);
SystemActions.bind_property('can-switch-user', switchUser, 'visible', bindFlags);

separator2 = new PopupMenu.PopupSeparatorMenuItem;
Menu.addMenuItem(separator2);

suspend = new PopupMenu.PopupImageMenuItem(_('Suspend'), 'media-playback-pause-symbolic');
suspend.connect('activate', () => { SystemActions.activateSuspend(); });
Menu.addMenuItem(suspend);
SystemActions.bind_property('can-suspend', suspend, 'visible', bindFlags);

powerOff = new PopupMenu.PopupImageMenuItem(_('Power Off'), 'system-shutdown-symbolic');
powerOff.connect('activate', () => { SystemActions.activatePowerOff(); });
Menu.addMenuItem(powerOff);
SystemActions.bind_property('can-power-off', powerOff, 'visible', bindFlags);
}

function disable() {
Menu.box.remove_child(separator1);
Menu.box.remove_child(logout);
Menu.box.remove_child(switchUser);
Menu.box.remove_child(separator2);
Menu.box.remove_child(suspend);
Menu.box.remove_child(powerOff);
Menu.addMenuItem(SubMenu);
}
